nobomber=0
bomber=0
victimcount=0
lollipoppypop=0
countdown=0
countdown2=0
countdown3=0
downcount=0

function mission_start()
	cc.rpg.rocket.move=rpgmissilereplace
	cc.zjpistol.bullet.move=pistolbulletreplace
end

function rpgmissilereplace(id,fx)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Particle Tail
	if (fx==1) then
		particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlefadealpha(0.01)
		particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
		particlefadealpha(0.04)
	end
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()*0.1
	projectiles[id].sy=projectiles[id].sy+getgravity()*0.12
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3)==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
				terraincircle(projectiles[id].x,projectiles[id].y,30,0x00000000)
				terrainexplosion(projectiles[id].x,projectiles[id].y,0,3)
				particle(p_ring,projectiles[id].x,projectiles[id].y)
				particlesize(0.3,0.3)
				arealdamage(projectiles[id].x,projectiles[id].y,65,100)
				-- Crater
				grey=math.random(0,25)
				terrainalphaimage(gfx_crater150,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				-- Free projectile
				freeprojectile(id)
				break
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			break
		end
	end
end

function pistolbulletreplace(id)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby		
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
				-- Cause damage
				if playercollision()~=0 and playercollision()~=projectiles[id].ignore then
					playerpush(playercollision(),projectiles[id].sx/10.0,projectiles[id].sy/10.0)
					playerdamage(playercollision(),10)
					blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
				elseif objectcollision()>0 then
					objectdamage(objectcollision(),10)
				end
				-- Effects
				playsound(sfx_ricochet1)
				particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				particlefadealpha(0.006)
				particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				-- Free projectile
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			if math.random(1,2)==1 then
				playsound(sfx_hitwater2)
			else
				playsound(sfx_hitwater3)
			end
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
end

function mission_update()
	nobomber=#objecttable(cc.friend_panic.id)
	bomber=#objecttable(cc.friend_panic_bomb.id)
	victimcount=nobomber+bomber
	if countdown>=200 and math.random(1,2)==1 then
		createobject(cc.friend_panic.id,math.random(0,getmapwidth()),0)
		lollipoppypop=lollipoppypop+1
		countdown=0
	else
		countdown=countdown+1
	end
	if countdown2>=200 and math.random(1,4)==1 and lollipoppypop>=50 then
		createobject(cc.missileobj.id,math.random(0,getmapwidth()),-96)
		countdown2=0
	else
		countdown2=countdown2+1
	end
	if countdown3>=200 and math.random(1,6)==1 and lollipoppypop>=70 then
		createobject(cc.friend_panic_bomb.id,math.random(0,getmapwidth()),0)
		countdown3=0
	else
		countdown3=countdown3+1
	end
	if downcount>=350 and getplayerhealth(0)<=50 then
		if math.random(1,3)==1 then
			createobject(o_medikit,math.random(0,getmapwidth()),0)
		else
			createobject(o_supply,math.random(0,getmapwidth()),0)
		end
		downcount=0
	else
		downcount=downcount+1
	end
	if lollipoppypop>=500 then
		watery(getwatery()-50)
	end
end