function mission_start()
cc.shieldgen.gen.removeshields=removeshields
cc.missileobj.update=missileexplode
cc.explosives.expl.update=motherofbombs
end

function motherofbombs(id,x,y)
	-- Gravity influence on speed
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.explosives.gfx_wpn,x,y,1,1,1,-1,id)==1 then
			if (math.abs(objects[id].sy)>0.5) then playsound(cc.explosives.sfx_bounce) end
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			return
		end
	end
	objectposition(id,x,y)
	-- Explode (delayed)
	if objects[id].timer>0 then
		objects[id].timer=objects[id].timer+1
		if objects[id].timer>=20 then
			-- Destroy terrain
			terrainexplosion(x,y,52,1)
			-- Crater
			grey=math.random(0,40)
			if math.random(0,1)==1 then
				terrainalphaimage(gfx_crater125,getobjectx(id),getobjecty(id),math.random(6,9)*0.1,grey,grey,grey)
			else
				terrainalphaimage(gfx_crater150,getobjectx(id),getobjecty(id),math.random(6,9)*0.1,grey,grey,grey)
			end
			-- Remove
			removeobject(id)
			-- Cause damage
			arealdamage(x,y,100,80)
		end
	-- Fire Collision?
	elseif firecollision(cc.explosives.gfx_wpn,x,y)>0 then
		objects[id].timer=1
	end
end

function missileexplode(id,x,y)
	-- Explode
	if objects[id].health<=0 then
		terrainexplosion(x,y,20,3)
		arealdamage(x,y,70,50)
		removeobject(id)
		-- Effect
		for i=1,math.random(2,3) do
			particle(p_firefragment,x,y)
			particlespeed(math.random(-1.5,1.5),math.random(-4.0,-1.0))
		end
		playsound(loadsfx("firefragment.wav"))
		-- Crater
		grey=math.random(0,40)
		terrainalphaimage(gfx_crater100,x,y,math.random(6,9)*0.1,grey,grey,grey)
	end
	-- Gravity influence on speed
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.missileobj.gfx,x,y,1,1,1,-1,id)==1 then
			objects[id].health=0
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
end

function removeshields(id)
	-- Remove all Shields
	shields=objecttable()
	for i=1,#shields do
		--Is Shield?
		local typ=getobjecttype(shields[i])
		if typ>=cc.shieldgen.shield0.id and typ<=cc.shieldgen.shield3.id then
			--Remove FX
			particle(p_muzzle,getobjectx(shields[i]),getobjecty(shields[i]))
			particlesize(1,1)
			particlecolor(255,100,150)
			particlealpha(0.8)
			particlefadealpha(0.01)
			for j=1,3 do
				particle(p_spark,getobjectx(shields[i])+math.random(-5,5),getobjecty(shields[i])+math.random(-5,5))
				particlecolor(255,100,150)
				particlealpha(0.5+math.random()*3.0)
				particlesize(0.8+math.random(2,6)*0.1,0.8+math.random(2,6)*0.1)
			end
			--Remove
			removeobject(shields[i])
		end
	end
end