--------------------------------------------------------------------------------
-- Weapon csaw
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.csaw={}

-- Load & Prepare Ressources
cc.csaw.gfx_wpn=loadgfx("ZJ/chainsaw0.bmp")						-- Weapon Image
setmidhandle(cc.csaw.gfx_wpn)
cc.csaw.gfx_wpn2=loadgfx("ZJ/chainsaw1.bmp")						-- Weapon Image
setmidhandle(cc.csaw.gfx_wpn2)
cc.csaw.sfx_attack=loadsfx("chainsawlaunch.wav")								-- Attack Sound
cc.csaw.sfx_hit=loadsfx("sawcut.ogg")								-- Slice Sound

--------------------------------------------------------------------------------
-- Weapon: csaw
--------------------------------------------------------------------------------

cc.csaw.id=addweapon("cc.csaw","Chainsaw",cc.csaw.gfx_wpn,100,1,"shortrange")	-- Add Weapon

function cc.csaw.draw()												-- Draw
	if weapon_timer>0 then
		weapon_timer=weapon_timer-0.3
	end
	if getplayeraction(0)==0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(getplayerdirection(0),1)
		setrotation(0)
		drawimage(cc.csaw.gfx_wpn,getplayerx(0)+getplayerdirection(0)*(10+weapon_timer),getplayery(0)+3)
	end
end

function cc.csaw.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1 and weapon_timer>=0) then
			-- No more weapon switching!
			useweapon(1)
			playsound(cc.csaw.sfx_attack)
			weapon_shots=weapon_shots+1
			weapon_timer=8
			-- Effect
			particle(p_smoke,getplayerx(0)+3,getplayery(0)+4)
			particlecolor(98,98,98)
			particlespeed(0,-2.0)
			particlefadealpha(0.005)
			particle(p_smoke,getplayerx(0)+3,getplayery(0)-4)
			particlecolor(98,98,98)
			particlespeed(0,-2.0)
			particlefadealpha(0.005)
			particle(p_smoke,getplayerx(0)+3,getplayery(0)-10)
			particlecolor(98,98,98)
			particlespeed(0,-2.0)
			particlefadealpha(0.005)
			-- Collision
			col=0
            for dist=5,20,5 do
				for i=-2,2,1 do
					if col==0 then
						if collision(col5x5,getplayerx(0)+getplayerdirection(0)*24,getplayery(0)+5,0,0,1)==1 or collision(col5x5,getplayerx(0)+getplayerdirection(0)*20,getplayery(0)+5,0,0,1)==1 or collision(col5x5,getplayerx(0)+getplayerdirection(0)*16,getplayery(0)+5,0,0,1)==1 or collision(col5x5,getplayerx(0)+getplayerdirection(0)*12,getplayery(0)+5,0,0,1)==1 or collision(col5x5,getplayerx(0)+getplayerdirection(0)*8,getplayery(0)+5,0,0,1)==1 or collision(col5x5,getplayerx(0)+getplayerdirection(0)*4,getplayery(0)+5,0,0,1)==1 then
							if objectcollision()>0 then
								playsound(cc.csaw.sfx_hit)
								objectdamage(objectcollision(),50)
								particle(p_ring,getplayerx(0)+getplayerdirection(0)*18,getplayery(0)+5)
                                particlecolor(195,195,195)
								col=1
								break
							end
						end
					end
				end
				-- End turn
				endturn()
            end
		end
	end
end
