--------------------------------------------------------------------------------
-- Straw Dummy
-- Original Carnage Contest Object
-- Script by DC, August 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.enemy_unarmed={}

-- Load & Prepare Ressources
cc.enemy_unarmed.gfx=loadgfx("ZJ/enemy_unarmed.png")						-- Straw dummy graphic
sethandle(cc.enemy_unarmed.gfx,11,15)
cc.enemy_unarmed.gfx2=loadgfx("ZJ/enemy_unarmed2.png")						-- Straw dummy graphic
sethandle(cc.enemy_unarmed.gfx2,11,15)
cc.enemy_unarmed.arrow=0													-- Draw Arrow (setting 1/0)

--------------------------------------------------------------------------------
-- Object: Straw Dummy
--------------------------------------------------------------------------------

cc.enemy_unarmed.id=addobject("cc.enemy_unarmed",cc.enemy_unarmed.gfx)			-- Add Object
function cc.enemy_unarmed.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=50
	objects[id].hurt=0
	objects[id].sy=0
end
function cc.enemy_unarmed.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setrotation(0)
	if getplayerx(0)>x then
	setscale(1,1)
	else
	setscale(-1,1)
	end
	-- Draw
	if objects[id].hurt>1 then
		drawimage(cc.enemy_unarmed.gfx2,x,y)
	else
		drawimage(cc.enemy_unarmed.gfx,x,y)
	end
	-- Arrow
	if cc.enemy_unarmed.arrow==1 then
		outofscreenarrow(x,y)
	end
end
function cc.enemy_unarmed.update(id,x,y)
	if objects[id].health<=0 then
		playsound(sfx_splatter1)
		particle(p_ring,x,y)
		particlecolor(255,0,0)
        particle(p_bodypart,x,y)
        particlecolor(255,255,0)
        for i = 1,3 do
        blood(x,y)
        end
        removeobject(id)
        return
	end
	-- Countdown
	objects[id].hurt=objects[id].hurt-1
	-- Fall
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.enemy_unarmed.gfx,x,y,1,1,1,-1,id)==1 then
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
end
function cc.enemy_unarmed.damage(id,damage)
	if objects[id].health>0 then 
		objects[id].health=objects[id].health-damage
		objects[id].hurt=18
		if (damage>=1 and damage<=5) then
			particle(p_bigblood,getobjectx(id),getobjecty(id))
			particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
		elseif (damage>=6 and damage<=10) then
			for i = 1,2 do
				particle(p_bigblood,getobjectx(id),getobjecty(id))
				particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
			end
		elseif (damage>=11 and damage<=15) then
			for i = 1,3 do
				particle(p_bigblood,getobjectx(id),getobjecty(id))
				particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
			end
		elseif (damage>=16 and damage<=20) then
			for i = 1,4 do
				particle(p_bigblood,getobjectx(id),getobjecty(id))
				particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
			end
		elseif (damage>=21 and damage<=25) then
			for i = 1,5 do
				particle(p_bigblood,getobjectx(id),getobjecty(id))
				particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
			end
		elseif (damage>=26 and damage<=30) then
			for i = 1,6 do
				particle(p_bigblood,getobjectx(id),getobjecty(id))
				particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
			end
		elseif (damage>=36 and damage<=40) then
			for i = 1,7 do
				particle(p_bigblood,getobjectx(id),getobjecty(id))
				particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
			end
		elseif (damage>=41 and damage<=45) then
			for i = 1,7 do
				particle(p_bigblood,getobjectx(id),getobjecty(id))
				particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
			end
		elseif (damage>=26) then
			for i = 1,8 do
				particle(p_bigblood,getobjectx(id),getobjecty(id))
				particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
			end
		end
	end
end