--------------------------------------------------------------------------------
-- Straw Dummy
-- Original Carnage Contest Object
-- Script by DC, August 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.missileobj={}

-- Load & Prepare Ressources
cc.missileobj.gfx=loadgfx("ZJ/missile.bmp")						-- Straw dummy graphic
setmidhandle(cc.missileobj.gfx)

--------------------------------------------------------------------------------
-- Object: Straw Dummy
--------------------------------------------------------------------------------

cc.missileobj.id=addobject("cc.missileobj",cc.missileobj.gfx)			-- Add Object
function cc.missileobj.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=1
	objects[id].sy=0
end
function cc.missileobj.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(0)
	-- Draw
	drawimage(cc.missileobj.gfx,x,y)
end
function cc.missileobj.update(id,x,y)
	-- Explode
	if objects[id].health<=0 then
		terraincircle(x,y,30,0x00000000)
		terrainexplosion(getobjectx(id),getobjecty(id),0,3)
		particle(p_ring,x,y)
		particlesize(0.3,0.3)
		arealdamage(x,y,65,100)
		removeobject(id)
		-- Crater
		grey=math.random(0,25)
		terrainalphaimage(gfx_crater150,x,y,math.random(6,9)*0.1,grey,grey,grey)
	end
	-- Gravity influence on speed
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.missileobj.gfx,x,y,1,1,1,-1,id)==1 then
			objects[id].health=0
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
end
function cc.missileobj.damage(id,damage)
	if objects[id].health>0 then 
		objects[id].health=objects[id].health-damage
	end
end