--------------------------------------------------------------------------------
-- Weapon Punch
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.punch={}

-- Load & Prepare Ressources
cc.punch.gfx_wpn=loadgfx("weapons/push.bmp")						-- Weapon Image
setmidhandle(cc.punch.gfx_wpn)
cc.punch.sfx_attack=loadsfx("throw.ogg")								-- Attack Sound
cc.punch.sfx_hit=loadsfx("punch.wav")

--------------------------------------------------------------------------------
-- Weapon: Punch
--------------------------------------------------------------------------------

cc.punch.id=addweapon("cc.punch","Fists",cc.punch.gfx_wpn,100,1,"shortrange")	-- Add Weapon

function cc.punch.draw()												-- Draw
	-- Decrease Timer (used for arm animation)
	if weapon_timer>0.0 then
		weapon_timer=weapon_timer-0.5
	end
	-- Draw
	if getplayeraction(0)==0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(-getplayerdirection(0),1)
		setrotation(0)
		drawimage(cc.punch.gfx_wpn,getplayerx(0)+getplayerdirection(0)*(7+weapon_timer),getplayery(0)+5)
	end
end

function cc.punch.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(1)
			playsound(cc.punch.sfx_attack)
			weapon_shots=weapon_shots+1
			-- Set timer for arm animation
			weapon_timer=7
			-- Collision
			col=0
            for dist=5,20,5 do
				for i=-2,2,1 do
					if col==0 then
						if collision(col5x5,getplayerx(0)+getplayerdirection(0)*9,getplayery(0)+5,0,0,1)==1 then
							if objectcollision()>0 then
								objectdamage(objectcollision(),5)
								playsound(cc.punch.sfx_hit)
								particle(p_ring,getplayerx(0)+getplayerdirection(0)*9,getplayery(0)+5)
								particlecolor(245,165,55)
								col=1
								break
							end
						end
					end
				end
            end
			-- End Turn
			endturn()
		end
	end
end
