--------------------------------------------------------------------------------
-- Straw Dummy
-- Original Carnage Contest Object
-- Script by DC, August 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.rainm={}

-- Load & Prepare Ressources
cc.rainm.gfx=loadgfx("ZJ/rainbowmachine.bmp")						-- Straw dummy graphic
cc.rainm.arrow=1													-- Draw Arrow (setting 1/0)
setmidhandle(cc.rainm.gfx)
cc.rainm.sfx_destroy=loadsfx("steam.ogg")

--------------------------------------------------------------------------------
-- Object: Straw Dummy
--------------------------------------------------------------------------------

cc.rainm.id=addobject("cc.rainm",cc.rainm.gfx)			-- Add Object
function cc.rainm.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=100
	objects[id].bow=0
	objects[id].smoke=0
	objects[id].hpefec=0
	objects[id].sy=0
end
function cc.rainm.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	if objects[id].health<=25 then
		setcolor(255,135,15)
	else
		setcolor(255,255,255)
	end
	setscale(1+math.abs(math.sin(id*10+os.clock()*2))*0.1,1+math.abs(math.sin(id*10+os.clock()*2))*0.1)
	setrotation(0)
	-- Draw
	drawimage(cc.rainm.gfx,x,y)
	-- Arrow
	if cc.rainm.arrow==1 then
		outofscreenarrow(x,y)
	end
end
function cc.rainm.update(id,x,y)
	-- Destroy
	if objects[id].health<=0 then
			particle(p_explosion,getobjectx(id)+16,getobjecty(id)+8)
			particlecolor(0,0,255)
			particlesize(0.75,0.75)
			particlefadealpha(0.02)
			particlespeed(0.4,0.2)
			particle(p_explosion,getobjectx(id)-16,getobjecty(id)+8)
			particlecolor(255,255,0)
			particlesize(0.75,0.75)
			particlefadealpha(0.02)
			particlespeed(-0.4,0.2)
			particle(p_explosion,getobjectx(id),getobjecty(id)-16)
			particlecolor(255,0,0)
			particlesize(0.75,0.75)
			particlefadealpha(0.02)
			particlespeed(0.0,-0.4)
		for i = 1,10 do
			particle(p_spark,getobjectx(id)+math.random(-8,8),getobjecty(id)-8)
			particlecolor(255,0,0)
			particlefadealpha(0.01)
			particle(p_spark,getobjectx(id)+math.random(-8,8),getobjecty(id)-8)
			particlecolor(255,128,0)
			particlefadealpha(0.01)
			particle(p_spark,getobjectx(id)+math.random(-8,8),getobjecty(id)-8)
			particlecolor(255,255,0)
			particlefadealpha(0.01)
			particle(p_spark,getobjectx(id)+math.random(-8,8),getobjecty(id)-8)
			particlecolor(0,255,0)
			particlefadealpha(0.01)
			particle(p_spark,getobjectx(id)+math.random(-8,8),getobjecty(id)-8)
			particlecolor(0,0,255)
			particlefadealpha(0.01)
			particle(p_spark,getobjectx(id)+math.random(-8,8),getobjecty(id)-8)
			particlecolor(255,0,255)
			particlefadealpha(0.01)
		end
		for i = 1,2 do
		playsound(cc.rainm.sfx_destroy)
		end
		removeobject(id)
	elseif objects[id].health<=25 then
		local f=getframe()
		if f%4==0 then
			particle(p_smoke,x-math.random(8,11),y-12)
			particlespeed(math.random(-2,2)*0.1,-1)
			particlefadealpha(0.01)
			particle(p_spark,x-9,y-9)
		end
		if f%6==0 then
			particle(p_lightpuff,x-math.random(8,11),y-11)
			particlespeed(math.random(-2,2)*0.1,-1)
			particlefadealpha(0.04)
		end
	else
	-- Rainbow function
	if objects[id].bow>=10 and objects[id].bow<=50 then
		particle(p_muzzle,x,y+3)
		particlesize(0.3,0.3)
		particlecolor(math.random(0,255),math.random(0,255),math.random(0,255))
		particlealpha(0.8)
		particlefadealpha(0.5)
		particlespeed(0.0,0.0)
	elseif objects[id].bow==70 then
		particle(p_ring,x,y+3)
		particlecolor(255,0,0)
		objects[id].bow=0
	elseif objects[id].bow==68 then
		particle(p_ring,x,y+3)
		particlecolor(255,128,0)
	elseif objects[id].bow==66 then
		particle(p_ring,x,y+3)
		particlecolor(255,255,0)
	elseif objects[id].bow==64 then
		particle(p_ring,x,y+3)
		particlecolor(0,255,0)
	elseif objects[id].bow==62 then
		particle(p_ring,x,y+3)
		particlecolor(0,0,255)
	elseif objects[id].bow==60 then
		particle(p_ring,x,y+3)
		particlecolor(255,0,255)
	end
	objects[id].bow=objects[id].bow+1
	-- Steam effect
	if objects[id].smoke==45 then
		particle(p_smoke,x-8,y-12)
		particlecolor(255,0,0)
		particlesize(8,8)
		particlealpha(1.5)
		particlespeed(0.0,-0.5)
		elseif objects[id].smoke==90 then
		particle(p_smoke,x-8,y-12)
		particlecolor(255,255,0)
		particlesize(8,8)
		particlealpha(1.5)
		particlespeed(0.0,-0.5)
		elseif objects[id].smoke==135 then
		particle(p_smoke,x-8,y-12)
		particlecolor(0,0,255)
		particlesize(8,8)
		particlealpha(1.5)
		particlespeed(0.0,-0.5)
		objects[id].smoke=0
		end
	objects[id].smoke=objects[id].smoke+1
	end
	-- Health effect
	if objects[id].hpefec==50 then
		if objects[id].health<=25 then
			objects[id].health=objects[id].health-5
		end
		objects[id].hpefec=0
	end
	objects[id].hpefec=objects[id].hpefec+1
	-- Gravity influence on speed
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.rainm.gfx,x,y,1,1,1,-1,id)==1 then
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
end
function cc.rainm.damage(id,damage)
	if objects[id].health>0 then 
		objects[id].health=objects[id].health-damage
	end
end