--------------------------------------------------------------------------------
-- Straw Dummy
-- Original Carnage Contest Object
-- Script by DC, August 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.leg={}

-- Load & Prepare Ressources
cc.leg.gfx=loadgfx("ZJ/leg.bmp")						-- Straw dummy graphic
cc.leg.arrow=0													-- Draw Arrow (setting 1/0)
sethandle(cc.leg.gfx,3,2)

--------------------------------------------------------------------------------
-- Object: Straw Dummy
--------------------------------------------------------------------------------

cc.leg.id=addobject("cc.leg",cc.leg.gfx)			-- Add Object
function cc.leg.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=10
	objects[id].sy=0
end
function cc.leg.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(0)
	-- Draw
	drawimage(cc.leg.gfx,x,y)
	-- Arrow
	if cc.leg.arrow==1 then
		outofscreenarrow(x,y)
	end
end
function cc.leg.update(id,x,y)
	-- Gravity influence on speed
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.leg.gfx,x,y,1,1,1,-1,id)==1 then
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
end
function cc.leg.damage(id,damage)
	if objects[id].health>0 then 
		objects[id].health=objects[id].health-damage
		if (damage>=1 and damage<=5) then
			particle(p_bigblood,getobjectx(id),getobjecty(id))
			particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
		elseif (damage>=6) then
			for i = 1,2 do
				particle(p_bigblood,getobjectx(id),getobjecty(id))
				particlespeed(math.random(-1.5,1.5),math.random(-4,-2))
			end
		end
		if objects[id].health<=0 then
			blood(getobjectx(id),getobjecty(id))
			removeobject(id)
		end
	end
end