--------------------------------------------------------------------------------
-- Submarine
-- Edited Carnage Contest Object
-- Original Script by DC, August 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.submarine_right={}

-- Load & Prepare Ressources
cc.submarine_right.gfx=loadgfx("ZJ/submarine_r.bmp")						-- Straw dummy graphic
cc.submarine_right.arrow=1													-- Draw Arrow (setting 1/0)
sethandle(cc.submarine_right.gfx,107,35)

--------------------------------------------------------------------------------
-- Object: Submarine
--------------------------------------------------------------------------------

cc.submarine_right.id=addobject("cc.submarine_right",cc.submarine_right.gfx)			-- Add Object
function cc.submarine_right.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=500
	objects[id].die=0
	objects[id].death=0
	objects[id].sy=0
end
function cc.submarine_right.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	if objects[id].die==1 then
		setcolor(135,135,135)
	else
		setcolor(255,255,255)
	end
	setscale(1,1)
	setrotation(math.sin(id*3+os.clock()*0.5)*3.0)
	-- Draw
	drawimage(cc.submarine_right.gfx,x,y)
	-- Arrow
	if cc.submarine_right.arrow==1 then
		outofscreenarrow(x,y)
	end
end
function cc.submarine_right.update(id,x,y)
	--Float
	objectposition(id,x,getwatery()-60)
	-- Sink
	if objects[id].die==1 then
		if objects[id].death==5 then
			particle(p_smoke,getobjectx(id)-80,getobjecty(id)-math.random(1,31))
			particlecolor(135,135,135)
			particlesize(math.random(25,30),math.random(25,35))
			particlealpha(1.5)
			particlespeed(math.random(-0.2,0.2),math.random(-0.6,-0.54))
			particle(p_smoke,getobjectx(id)-32,getobjecty(id)-math.random(1,31))
			particlecolor(135,135,135)
			particlesize(math.random(25,30),math.random(25,35))
			particlealpha(1.5)
			particlespeed(math.random(-0.2,0.2),math.random(-0.6,-0.54))
			particle(p_smoke,getobjectx(id)+32,getobjecty(id)-math.random(1,31))
			particlecolor(135,135,135)
			particlesize(math.random(25,30),math.random(25,35))
			particlealpha(1.5)
			particlespeed(math.random(-0.2,0.2),math.random(-0.6,-0.54))
			particle(p_smoke,getobjectx(id)+80,getobjecty(id)-math.random(1,31))
			particlecolor(135,135,135)
			particlesize(math.random(25,30),math.random(25,35))
			particlealpha(1.5)
			particlespeed(math.random(-0.2,0.2),math.random(-0.6,-0.54))
			particle(p_smoke,getobjectx(id),getobjecty(id)-math.random(1,31))
			particlecolor(135,135,135)
			particlesize(math.random(25,30),math.random(25,35))
			particlealpha(1.5)
			particlespeed(math.random(-0.2,0.2),math.random(-0.6,-0.54))
		elseif objects[id].death==30 then
			particle(p_waterhit,x,y+2)
			particlesize(4,2)
			playsound(sfx_hitwater1)
			removeobject(id)
		end
		objects[id].death=objects[id].death+1
		objectposition(id,x,y+2)
	end
end
function cc.submarine_right.damage(id,damage)
	if objects[id].health>0 then 
		objects[id].health=objects[id].health-damage
		if objects[id].health<=0 then
			objects[id].die=1
		end
	end
end