--------------------------------------------------------------------------------
-- Straw Dummy
-- Original Carnage Contest Object
-- Script by DC, August 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.tank={}

-- Load & Prepare Ressources
cc.tank.gfx=loadgfx("ZJ/tank.bmp")						-- Straw dummy graphic
cc.tank.arrow=1													-- Draw Arrow (setting 1/0)
sethandle(cc.tank.gfx,64,40)
cc.tank.gfx_ded=loadgfx("ZJ/tank2.png")
sethandle(cc.tank.gfx_ded,64,40)

--------------------------------------------------------------------------------
-- Object: Straw Dummy
--------------------------------------------------------------------------------

cc.tank.id=addobject("cc.tank",cc.tank.gfx)			-- Add Object
function cc.tank.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=300
	objects[id].sy=0
end
function cc.tank.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setrotation(0)
	setscale(1,1)
	-- Draw
	drawimage(cc.tank.gfx,x,y)
	-- Arrow
	if cc.tank.arrow==1 then
		outofscreenarrow(x,y)
	end
end
function cc.tank.update(id,x,y)
	-- Gravity influence on speed
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.tank.gfx,x,y,1,1,1,-1,id)==1 then
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
end
function cc.tank.damage(id,damage)
	if objects[id].health>0 then 
		objects[id].health=objects[id].health-damage
		if objects[id].health<=0 then
			local x=getobjectx(id)
			local y=getobjecty(id)
			-- Explosion
			terrainexplosion(x,y,40,3)
			-- Remain
			terrainimage(cc.tank.gfx_ded,x,y)
			-- Remove
			removeobject(id)
		end
	end
end