--------------------------------------------------------------------------------
-- Weapon Explosives
-- Original Carnage Contest Weapon
-- Script by DC, September 2010, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.timebomb={}
cc.timebomb.wpn={}

-- Load & Prepare Ressources
cc.timebomb.sfx_tick=loadsfx("bombtick.wav")										-- Bounce
cc.timebomb.gfx_wpn=loadgfx("ZJ/timebomb.bmp")
setmidhandle(cc.timebomb.gfx_wpn)

--------------------------------------------------------------------------------
-- Weapon: Explosives
--------------------------------------------------------------------------------

cc.timebomb.wpn.id=addweapon("cc.timebomb.wpn","Timebomb",cc.timebomb.gfx_wpn,100,1)	-- Add Weapon (1 use, first in round 2)

function cc.timebomb.wpn.draw()														-- Draw
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_build,cc.timebomb.gfx_wpn,222,0,1)
	end
end

function cc.timebomb.wpn.attack(attack)												-- Attack
	if (weapon_shots<=0) and (weapon_position==1) then
		-- No more weapon switching!
		useweapon(1)
		weapon_shots=weapon_shots+1
		createobject(cc.timebomb.id,weapon_x,weapon_y)
		-- End Turn
		endturn()
	end
end

--------------------------------------------------------------------------------
-- Object: Explosives
--------------------------------------------------------------------------------

cc.timebomb.id=addobject("cc.timebomb",cc.timebomb.gfx_wpn)			-- Add Object

function cc.timebomb.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].timer=1
	objects[id].sy=0
end

function cc.timebomb.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1+math.abs(math.sin(id*10+os.clock()*2))*0.15,1+math.abs(math.sin(id*10+os.clock()*2))*0.25)
	setrotation(0)
	-- Tick
	if channelplaying(1)==0 then
		playsound(cc.timebomb.sfx_tick,1)
	end
	if getframe()%10==0 then
		particle(p_muzzle,x,y-1)
		particlealpha(1)
		particlesize(0.45,0.45)
		particlecolor(0,255,0)
		particlefadealpha(0.09)
		particlespeed(0.0,0.0)
	end
	-- Draw
	drawimage(cc.timebomb.gfx_wpn,x,y)
end

function cc.timebomb.update(id,x,y)
	objectposition(id,x,y)
	-- Explode (delayed)
	if objects[id].timer>0 then
		objects[id].timer=objects[id].timer+1
		if objects[id].timer>=500 then
			-- Destroy terrain
			terrainexplosion(x,y,50,3)
			terraincircle(x,y,55,0x00000000)
			-- Crater
			grey=math.random(0,40)
			if math.random(0,1)==1 then
				terrainalphaimage(gfx_crater125,getobjectx(id),getobjecty(id),math.random(6,9)*0.1,grey,grey,grey)
			else
				terrainalphaimage(gfx_crater150,getobjectx(id),getobjecty(id),math.random(6,9)*0.1,grey,grey,grey)
			end
			-- Remove
			removeobject(id)
			-- Cause damage
			arealdamage(x,y,85,120)
		end
	end
end
function cc.timebomb.damage(id,damage)
	objects[id].timer=objects[id].timer+damage
end
