--------------------------------------------------------------------------------
-- Straw Dummy
-- Original Carnage Contest Object
-- Script by DC, August 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.friend_invul={}

-- Load & Prepare Ressources
cc.friend_invul.gfx=loadgfx("ZJ/friend_unarmed.png")						-- Straw dummy graphic
sethandle(cc.friend_invul.gfx,11,15)
cc.friend_invul.gfx2=loadgfx("ZJ/friend_unarmed2.png")						-- Straw dummy graphic
sethandle(cc.friend_invul.gfx2,11,15)
cc.friend_invul.arrow=0													-- Draw Arrow (setting 1/0)

--------------------------------------------------------------------------------
-- Object: Straw Dummy
--------------------------------------------------------------------------------

cc.friend_invul.id=addobject("cc.friend_invul",cc.friend_invul.gfx)			-- Add Object
function cc.friend_invul.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].sy=0
end
function cc.friend_invul.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setrotation(0)
	if getplayerx(0)>=x then
	setscale(1,1)
	else
	setscale(-1,1)
	end
	drawimage(cc.friend_invul.gfx,x,y)
	-- Arrow
	if cc.friend_invul.arrow==1 then
		outofscreenarrow(x,y)
	end
end
function cc.friend_invul.update(id,x,y)
	-- Fall
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.friend_invul.gfx,x,y,1,1,1,-1,id)==1 then
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		-- Water
		if y>getwatery()+5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
end
function cc.friend_invul.damage(id,damage)
end